Index: reactapp/src/Pages/UserDashboard.js
===================================================================
--- reactapp/src/Pages/UserDashboard.js	(revision 4abf55a556ca76069528c751a92cddaa146d108d)
+++ reactapp/src/Pages/UserDashboard.js	(revision e49d1b6f77f15934314680ef2f5f20fec4987e7b)
@@ -1,5 +1,2 @@
-/* eslint-disable no-unused-vars */
-// noinspection JSUnresolvedVariable,ES6ConvertVarToLetConst,JSUnresolvedFunction,SpellCheckingInspection,JSUnusedLocalSymbols
-
 import React, { useEffect, useState, useContext } from "react";
 import {
@@ -26,5 +23,4 @@
     ModalInput
 } from "../Components/Styled/Modal.style";
-import LoadingSpinner from "../Components/Styled/LoadingSpinner.style";
 
 function UserDashboard() {
@@ -44,18 +40,7 @@
 
   const [newPostContent, setNewPostContent] = useState("");
-  const [newOpinionTargetProfessorId, setNewOpinionTargetProfessorId] = useState("");
-  const [newOpinionTargetProfessor, setNewOpinionTargetProfessor] = useState(null);
-  const [loadedNewProfessor,setLoadedNewProfessor] = useState(false);
-  const [newParentPostId, setNewParentPostId] = useState("-1");
-
-  const [newThreadTitle, setNewThreadTitle] = useState("");
-  const [newParentThreadId,setNewParentThreadId] = useState("-1");
-  const [newTargetSubjectId, setNewTargetSubjectId] = useState("");
-  const [newTargetSubject, setNewTargetSubject] = useState(null);
-  const [loadedNewSubject, setLoadedNewSubject] = useState(null);
+  const [newPostTitle, setNewPostTitle] = useState("");
 
   const [markResolved, setMarkResolved] = useState(false);
-
-  const [errMsg, setErrMsg] = useState("");
 
   const handleModalCloseClick = () => {
@@ -74,7 +59,5 @@
       if (reportForModal.post !== null) {
         setNewPostContent(reportForModal.post.content);
-        if(reportForModal.post.title !== null) setNewThreadTitle(reportForModal.post.title);
-        if(reportForModal.post.targetProfessor !== undefined) setNewOpinionTargetProfessorId(reportForModal.post.targetProfessor.professorId); //prvicnoto
-        if(reportForModal.post.targetProfessor === undefined) setNewTargetSubjectId(reportForModal.post.targetSubject.subjectId); //prvicnoto
+        if(reportForModal.post.title !== null) setNewPostTitle(reportForModal.post.title);
       }
       setReportModalDisplay("block");
@@ -83,47 +66,7 @@
   }, [reportForModal]);
 
-  const[loadingProf, setLoadingProf] = useState(false);
-
-  const handleNewTargetProfessorChange = async (e) => {
-    setLoadingProf(true);
-    e.preventDefault();
-    if (newOpinionTargetProfessorId!=="") {
-        try {
-          const response = await axios.get(`http://192.168.0.29:8080/public/professor/${newOpinionTargetProfessorId}`, {withCredentials: true});
-          let cyclicGraph = await response.data;
-          var jsogStructure = JSOG.encode(cyclicGraph);
-          cyclicGraph = JSOG.decode(jsogStructure);
-          setNewOpinionTargetProfessor(cyclicGraph);
-          setLoadedNewProfessor(true);
-          setLoadingProf(false);
-        } catch (error) {
-          setFetchError(true);
-        }
-    }
-  }
-
-  const[loadingSubj, setLoadingSubj] = useState(false);
-
-  const handleNewTargetSubjectChange = async (e) => {
-    e.preventDefault();
-    setLoadingSubj(true);
-    if (newTargetSubjectId!=="") {
-      try {
-        const response = await axios.get(`http://192.168.0.29:8080/public/subject/${newTargetSubjectId}`, {withCredentials: true});
-        let cyclicGraph = await response.data;
-        var jsogStructure = JSOG.encode(cyclicGraph);
-        cyclicGraph = JSOG.decode(jsogStructure);
-        setNewTargetSubject(cyclicGraph);
-        setLoadedNewSubject(true);
-        setLoadingSubj(false);
-      } catch (error) {
-        setFetchError(true);
-      }
-    }
-  }
-
   useEffect(() => {
-    const url1 = `http://192.168.0.29:8080/secure/currentUser`;
-    const url2 = `http://192.168.0.29:8080/secure/getAllPostReports`;
+    const url1 = `http://192.168.0.19:8080/secure/currentUser`;
+    const url2 = `http://192.168.0.19:8080/secure/getAllPostReports`;
 
     const fetchUser = async () => {
@@ -162,5 +105,5 @@
   // useEffect(() => {
   //   const timer = setTimeout(() => {
-  //     if (user === null) window.location.reload(); <---- :-)
+  //     if (user === null) window.location.reload(false); <---- :-)
   //   }, 3000);
   //   return () => clearTimeout(timer);
@@ -176,5 +119,5 @@
     try {
       if(reportForModal.post !== null && reportForModal.post.targetProfessor !== undefined) {
-        await axios(`http://192.168.0.29:8080/secure/updateOpinion/${reportForModal.post.postId}`,
+        await axios(`http://192.168.0.19:8080/secure/updateOpinion/${reportForModal.post.postId}`,
             {
               method: "put",
@@ -182,90 +125,28 @@
                 newContent: newPostContent,
                 newTargetProfessorId: reportForModal.post.targetProfessor.professorId,
-                newParentPostId: reportForModal.post.parent !== null ? reportForModal.post.parent.postId : "-1"
               },
               withCredentials: true,
             })
+        window.location.reload(false);
       } else if(reportForModal.post !== null && reportForModal.post.targetProfessor === undefined) {
-        await axios(`http://192.168.0.29:8080/secure/updateThread/${reportForModal.post.postId}`,
+        await axios(`http://192.168.0.19:8080/secure/updateThread/${reportForModal.post.postId}`,
             {
               method: "put",
               data: {
-                newTitle: newThreadTitle,
+                newTitle: newPostTitle,
                 newContent: newPostContent,
-                newTargetSubjectId: reportForModal.post.targetSubject.subjectId,
-                newParentThreadId: reportForModal.post.parent !== null ? reportForModal.post.parent.postId : "-1"
+                newTargetSubjectId: reportForModal.post.targetSubject.subjectId
               },
               withCredentials: true,
             })
-      }
-        await axios(`http://192.168.0.29:8080/secure/markReportResolved/${reportForModal.postReportId}/${markResolved ? `resolve` : `open`}`,{
-          method: "get",
-          withCredentials: true
-        })
-    } catch (error) {
-      setFetchError(true);
-    }
-    window.location.reload();
-  }
-
-  const handleRelocate = async (e) => {
-    e.preventDefault();
-    try {
-      if(reportForModal.post !== null && reportForModal.post.targetProfessor !== undefined) {
-        var response = await axios(`http://192.168.0.29:8080/secure/updateOpinion/${reportForModal.post.postId}`,
-            {
-              method: "put",
-              data: {
-                newContent: reportForModal.post.content,
-                newTargetProfessorId: newOpinionTargetProfessorId,
-                newParentPostId: newParentPostId==="Постави како самостојно мислење" ? "-1" : newParentPostId //:)
-              },
-              withCredentials: true,
-            })
-      } else if(reportForModal.post !== null && reportForModal.post.targetProfessor === undefined) {
-        var response = await axios(`http://192.168.0.29:8080/secure/updateThread/${reportForModal.post.postId}`,
-            {
-              method: "put",
-              data: {
-                newTitle: newThreadTitle,
-                newContent: reportForModal.post.content,
-                newTargetSubjectId: newTargetSubjectId,
-                newParentThreadId: newParentThreadId==="Постави како самостојно мислење (нова тема)" ? "-1" : newParentThreadId //:)
-              },
-              withCredentials: true,
-            })
-      }
-      await axios(`http://192.168.0.29:8080/secure/markReportResolved/${reportForModal.postReportId}/${markResolved ? `resolve` : `open`}`,{
-        method: "get",
-        withCredentials: true
-      })
-    } catch (error) {
-      setFetchError(true);
-    }
-    setErrMsg(response.data);
-    if (response.data==="") window.location.reload();
-  }
-
-  const handleDelete = async (e) => {
-    e.preventDefault();
-    try {
-      if(reportForModal.post !== null && reportForModal.post.targetProfessor !== undefined) {
-        await axios(`http://192.168.0.29:8080/secure/deleteOpinion/${reportForModal.post.postId}`,
-            {
-              method: "delete",
-              withCredentials: true,
-            })
-        window.location.reload();
-      } else if(reportForModal.post !== null && reportForModal.post.targetProfessor === undefined) {
-        await axios(`http://192.168.0.29:8080/secure/deleteThread/${reportForModal.post.postId}`,
-            {
-              method: "delete",
-              withCredentials: true,
-            })
+        window.location.reload(false);
       }
     } catch (error) {
       setFetchError(true);
     }
-    window.location.reload();
+  }
+
+  const handleDelete = (e) => {
+    e.preventDefault();
   }
 
@@ -300,5 +181,5 @@
       ) : (
           <h3>Нема пријавени мислења</h3>
-      ) : loadedUser && user.userRole==='MODERATOR' ? <LoadingSpinner/> : ""}
+      ) : loadedUser && user.userRole==='MODERATOR' ? "се вчитува..." : ""}
       <EntityUl style={{marginTop:"25px"}}>
       {loadedPostReports && postReports.map((postReport) => {
@@ -344,5 +225,5 @@
                   {dateConverter(
                     new Date(post.timePosted).toString().slice(4, -43)
-                  )} <span style={{fontStyle:"normal",color:"blue"}}>#{post.postId}</span>
+                  )}
                 </OpinionCardContentTime>
               </OpinionCardContent>
@@ -406,5 +287,5 @@
                           {dateConverter(
                               new Date(reportForModal.post.timePosted).toString().slice(4, -43)
-                          )} <span style={{fontStyle:"normal",color:"blue"}}>#{reportForModal.post.postId}</span>
+                          )}
                         </OpinionCardContentTime>
                       </OpinionCardContent>
@@ -472,10 +353,9 @@
                   actionType === 0 ?
               (<form onSubmit={e => handleEdit(e)}>
-                {reportForModal.post.title !== null &&
-                    <label>
+                {reportForModal.post.title !== null && <label>
                   <b>Нов наслов на тема:</b>
                   <ModalInput
-                      value={newThreadTitle}
-                      onChange={e => setNewThreadTitle(e.target.value)}
+                      value={newPostTitle}
+                      onChange={e => setNewPostTitle(e.target.value)}
                       id="title"
                       spellCheck={false}
@@ -499,4 +379,5 @@
                   <input
                       type="checkbox"
+                      checked={markResolved}
                       onChange={handleMarkResolved}
                   />
@@ -522,88 +403,6 @@
                           </form>)
                           :
-                          (reportForModal.post.targetProfessor !== undefined ?
-                              (<form onSubmit={e => handleRelocate(e)}>
-                                <p style={{color:"black"}}>Внеси <span style={{fontWeight:"bold"}}>ID</span> на секцијата за дискусија (за <span style={{fontWeight:"bold"}}>професор</span>)
-                                    во која треба да биде преместено мислењето:</p>
-                                    <div style={{marginTop:"15px"}}>
-                                      <label>
-                                        <ModalInput
-                                            value={newOpinionTargetProfessorId}
-                                            onChange={e => {e.preventDefault();setNewOpinionTargetProfessorId(e.target.value)}}
-                                            id="newOpinionTargetProfessorId"
-                                            spellCheck={false}
-                                            style={{marginTop:"10px", marginBottom:"10px", width:"90px"}}
-                                        />
-                                        <button onClick={async (e) => {await handleNewTargetProfessorChange(e);}} style={{marginBottom:"10px", padding:"5px", fontFamily: "Roboto Mono, monospace"}}>Зачувај</button>
-                                        {newOpinionTargetProfessor!==null && !loadingProf ? <p style={{color:"black", marginBottom:"20px", opacity:"50%"}}>Мислењето ќе се премести во секцијата за професорот со <span style={{fontWeight:"bold"}}>ID=
-                                          {newOpinionTargetProfessor.professorId}</span> (<span style={{fontWeight:"bold"}}>{newOpinionTargetProfessor.professorName}</span>)</p> : loadingProf ? <LoadingSpinner style={{marginBottom:"15px", marginTop:"15px"}}/> : null}
-                                        {newOpinionTargetProfessor && <p style={{color:"black", marginBottom:"10px"}}>Постави како дете на мислење со ID:</p>}
-                                        {newOpinionTargetProfessor &&
-                                        <select value={newParentPostId} onChange={e => setNewParentPostId(e.target.value)} style={{width:"280px", display:"block", padding:"5px",marginBottom:"5px", fontFamily: "Roboto Mono, monospace"}}>
-                                          <option value="-1">Постави како самостојно мислење</option>
-                                          {newOpinionTargetProfessor.relatedOpinions.filter((opinion)=>opinion.postId!==reportForModal.post.postId).map((opinion) => {
-                                            return <option key={opinion.postId} value={opinion.postId}>{opinion.postId}</option>})
-                                          }
-                                        </select>}
-                                        <br/>
-                                        <input
-                                            type="checkbox"
-                                            defaultChecked={reportForModal.resolved}
-                                            onChange={handleMarkResolved}
-                                        />
-                                        <span style={{marginLeft:"10px", fontWeight:"bold"}}>Означи како разрешено</span>
-                                      </label>
-                                    </div>
-                                {errMsg!=="" && <p style={{color:"red", display:"flex", justifyContent:"space-around"}}>{errMsg}</p>}
-                                    <ModalFooter type="submit">ПОТВРДИ</ModalFooter>
-                                  </form>) :
-                              //THREAD CASE
-                              (<form onSubmit={e => handleRelocate(e)}>
-                                <p style={{color:"black"}}>Внеси <span style={{fontWeight:"bold"}}>ID</span> на секцијата за дискусија (за <span style={{fontWeight:"bold"}}>предмет</span>)
-                                  во која треба да биде преместено мислењето:</p>
-                                <div style={{marginTop:"15px"}}>
-                                  <label>
-                                    <ModalInput
-                                        value={newTargetSubjectId}
-                                        onChange={e => {e.preventDefault();setNewTargetSubjectId(e.target.value)}}
-                                        id="newTargetSubjectId"
-                                        spellCheck={false}
-                                        style={{marginTop:"10px", marginBottom:"10px", width:"90px"}}
-                                    />
-                                    <button onClick={async (e) => {await handleNewTargetSubjectChange(e);}} style={{marginBottom:"10px", padding:"5px", fontFamily: "Roboto Mono, monospace"}}>Зачувај</button>
-                                    {newTargetSubject!==null && !loadingSubj ? <p style={{color:"black", marginBottom:"20px", opacity:"50%"}}>Мислењето ќе се премести во секцијата за предметот со <span style={{fontWeight:"bold"}}>ID=
-                                      {newTargetSubject.subjectId}</span> (<span style={{fontWeight:"bold"}}>{newTargetSubject.subjectName}</span>)</p> : loadingSubj ? <LoadingSpinner style={{marginBottom:"15px", marginTop:"15px"}}/> : null}
-                                    {newTargetSubject && <p style={{color:"black", marginBottom:"10px"}}>Постави како дете на мислење со ID:</p>}
-                                    {newTargetSubject &&
-                                        <select value={newParentThreadId} onChange={e => setNewParentThreadId(e.target.value)} style={{width:"370px", display:"block", padding:"5px",marginBottom:"5px", fontFamily: "Roboto Mono, monospace"}}>
-                                          <option value="-1">Постави како самостојно мислење (нова тема)</option>
-                                          {newTargetSubject.threads.filter((thread)=>thread.postId!==reportForModal.post.postId).map((thread) => {
-                                            return <option key={thread.postId} value={thread.postId}>{thread.postId}</option>})
-                                          }
-                                        </select>}
-                                    {newParentThreadId==="-1" && loadedNewSubject &&
-                                        <>
-                                        <p style={{marginTop:"10px"}}>Наслов на нова тема:</p>
-                                      <ModalInput
-                                        value={newThreadTitle}
-                                        onChange={e => setNewThreadTitle(e.target.value)}
-                                        id="titleChangeRelocate"
-                                        spellCheck={false}
-                                        style={{marginTop:"10px"}}
-                                    />
-                                    </>}
-                                    <br/>
-                                    <input
-                                        type="checkbox"
-                                        defaultChecked={reportForModal.resolved}
-                                        onChange={handleMarkResolved}
-                                    />
-                                    <span style={{marginLeft:"10px", fontWeight:"bold"}}>Означи како разрешено</span>
-                                  </label>
-                                </div>
-                                {errMsg!=="" && <p style={{color:"red", display:"flex", justifyContent:"space-around"}}>{errMsg}</p>}
-                                <ModalFooter type="submit">ПОТВРДИ</ModalFooter>
-                              </form>))
-                  : null
+                          ("123")
+                          : null
               }
                 </ModalBody>
@@ -613,5 +412,5 @@
     </>
   ) : (
-      <LoadingSpinner/>
+    <>се вчитува...</>
   );
 }
Index: reactapp/src/api/axios.js
===================================================================
--- reactapp/src/api/axios.js	(revision 4abf55a556ca76069528c751a92cddaa146d108d)
+++ reactapp/src/api/axios.js	(revision e49d1b6f77f15934314680ef2f5f20fec4987e7b)
@@ -2,4 +2,4 @@
 
 export default axios.create({
-  baseURL: "http://192.168.0.29:8080",
+  baseURL: "http://192.168.0.19:8080",
 });
Index: springapp/src/main/java/mk/profesori/springapp/Controller/PublicController.java
===================================================================
--- springapp/src/main/java/mk/profesori/springapp/Controller/PublicController.java	(revision 4abf55a556ca76069528c751a92cddaa146d108d)
+++ springapp/src/main/java/mk/profesori/springapp/Controller/PublicController.java	(revision e49d1b6f77f15934314680ef2f5f20fec4987e7b)
@@ -25,5 +25,5 @@
 @RestController
 @RequestMapping("/public")
-@CrossOrigin(origins = { "http://192.168.0.29:3000", "http://192.168.0.28:3000" })
+@CrossOrigin(origins = { "http://192.168.0.19:3000", "http://192.168.0.39:3000" })
 public class PublicController {
 
Index: springapp/src/main/java/mk/profesori/springapp/Controller/SecureController.java
===================================================================
--- springapp/src/main/java/mk/profesori/springapp/Controller/SecureController.java	(revision 4abf55a556ca76069528c751a92cddaa146d108d)
+++ springapp/src/main/java/mk/profesori/springapp/Controller/SecureController.java	(revision e49d1b6f77f15934314680ef2f5f20fec4987e7b)
@@ -6,6 +6,4 @@
 import mk.profesori.springapp.Model.UserRole;
 import mk.profesori.springapp.Service.CustomUserDetailsService;
-import mk.profesori.springapp.Service.DisallowedOperationException;
-import mk.profesori.springapp.Service.IncompatiblePostId;
 import mk.profesori.springapp.Service.MainService;
 import org.apache.tomcat.websocket.AuthenticationException;
@@ -20,5 +18,5 @@
 @RestController
 @RequestMapping("/secure")
-@CrossOrigin(origins = { "http://192.168.0.29:3000", "http://192.168.0.28:3000" })
+@CrossOrigin(origins = { "http://192.168.0.19:3000", "http://192.168.0.39:3000" })
 public class SecureController {
 
@@ -135,5 +133,5 @@
 
     @RequestMapping(value = "/updateOpinion/{postId}", method = RequestMethod.PUT)
-    public String updateOpinion(@RequestBody ObjectNode objectNode, @PathVariable Long postId,
+    public void updateOpinion(@RequestBody ObjectNode objectNode, @PathVariable Long postId,
             @CurrentSecurityContext SecurityContext context) {
         Authentication authentication = context.getAuthentication();
@@ -142,17 +140,10 @@
             String newContent = objectNode.get("newContent").asText();
             Long newTargetProfessorId = objectNode.get("newTargetProfessorId").asLong();
-            Long newParentPostId = objectNode.get("newParentPostId").asLong();
-            try {
-                mainService.updateOpinion(newContent, newTargetProfessorId, newParentPostId, postId);
-            } catch (IncompatiblePostId | DisallowedOperationException e) {
-                return e.getMessage();
-            }
-        }
-
-        return null;
+            mainService.updateOpinion(newContent, newTargetProfessorId, postId);
+        }
     }
 
     @RequestMapping(value = "/updateThread/{postId}", method = RequestMethod.PUT)
-    public String updateThread(@RequestBody ObjectNode objectNode, @PathVariable Long postId,
+    public void updateThread(@RequestBody ObjectNode objectNode, @PathVariable Long postId,
             @CurrentSecurityContext SecurityContext context) {
         Authentication authentication = context.getAuthentication();
@@ -162,13 +153,12 @@
             String newContent = objectNode.get("newContent").asText();
             Long newTargetSubjectId = objectNode.get("newTargetSubjectId").asLong();
-            Long newParentThreadId = objectNode.get("newParentThreadId").asLong();
-            try {
+
+            if (objectNode.has("newParentThreadId")) {
+                Long newParentThreadId = objectNode.get("newParentThreadId").asLong();
                 mainService.update_Thread(newTitle, newContent, newTargetSubjectId, newParentThreadId, postId);
-            } catch (IncompatiblePostId | DisallowedOperationException e) {
-                return e.getMessage();
+            } else {
+                mainService.update_Thread(newTitle, newContent, newTargetSubjectId, null, postId);
             }
         }
-
-        return null;
     }
 
@@ -233,9 +223,8 @@
     }
 
-    @RequestMapping(value = "/markReportResolved/{postReportId}/{action}", method = RequestMethod.GET)
+    @RequestMapping(value = "/markReportResolved/{postReportId}/", method = RequestMethod.GET)
     public void markReportResolved(@PathVariable Long postReportId, @PathVariable String action, @CurrentSecurityContext SecurityContext context) {
         Authentication authentication = context.getAuthentication();
-        if (authentication != null && authentication.getPrincipal() instanceof CustomUserDetails currentUser &&
-                currentUser.getUserRole().equals(UserRole.MODERATOR)) {
+        if (authentication != null && authentication.getPrincipal() instanceof CustomUserDetails currentUser) {
             mainService.markReport(postReportId, action);
         }
Index: springapp/src/main/java/mk/profesori/springapp/Security/SecurityConfiguration.java
===================================================================
--- springapp/src/main/java/mk/profesori/springapp/Security/SecurityConfiguration.java	(revision 4abf55a556ca76069528c751a92cddaa146d108d)
+++ springapp/src/main/java/mk/profesori/springapp/Security/SecurityConfiguration.java	(revision e49d1b6f77f15934314680ef2f5f20fec4987e7b)
@@ -37,5 +37,5 @@
             @Override
             public void addCorsMappings(CorsRegistry registry) {
-                registry.addMapping("/**").allowedOrigins("http://192.168.0.29:3000", "http://192.168.0.28:3000")
+                registry.addMapping("/**").allowedOrigins("http://192.168.0.19:3000", "http://192.168.0.39:3000")
                         .allowCredentials(true);
             }
Index: springapp/src/main/java/mk/profesori/springapp/Service/MainService.java
===================================================================
--- springapp/src/main/java/mk/profesori/springapp/Service/MainService.java	(revision 4abf55a556ca76069528c751a92cddaa146d108d)
+++ springapp/src/main/java/mk/profesori/springapp/Service/MainService.java	(revision e49d1b6f77f15934314680ef2f5f20fec4987e7b)
@@ -141,7 +141,6 @@
     public void addThread(String title, String content, Long subjectId, CustomUserDetails currentUser) {
         Subject targetSubject = subjectRepository.findBySubjectId(subjectId);
-        String titleToSet = title.equals("") ? null : title;
-
-        _Thread _threadToAdd = new _Thread(titleToSet, content, currentUser, null, null, null, targetSubject);
+
+        _Thread _threadToAdd = new _Thread(title, content, currentUser, null, null, null, targetSubject);
         _threadRepository.save(_threadToAdd);
     }
@@ -200,5 +199,5 @@
     public void delete_Thread(Long postId) {_threadRepository.deleteById(postId);}
 
-    public String updateOpinion(String newContent, Long newTargetProfessorId, Long newParentPostId, Long postId) {
+    public void updateOpinion(String newContent, Long newTargetProfessorId, Long postId) {
         Opinion opinionToUpdate = opinionRepository.findByPostId(postId);
 
@@ -206,16 +205,5 @@
 
         Professor newTargetProfessor = professorRepository.findByProfessorId(newTargetProfessorId);
-        opinionToUpdate.setTargetProfessor(newTargetProfessor);
-
-        Opinion newParentOpinion = null;
-        if (newParentPostId != -1) {
-            newParentOpinion = opinionRepository.findByPostId(newParentPostId);
-            if (!newParentOpinion.getTargetProfessor().equals(newTargetProfessor))
-                throw new IncompatiblePostId("Мислењето не припаѓа во специфицираната секција за дискусија.");
-            if (opinionToUpdate.getChildren().contains(newParentOpinion))
-                throw new DisallowedOperationException("Мислењето не може да се постави како дете на негово дете (бесконечна рекурзија)");
-        }
-        opinionToUpdate.setParent(newParentOpinion);
-
+        opinionToUpdate.setTargetProfessor(newTargetProfessor); //opcijava da ja dava samo kaj postovi so parentPost==null
         for(Post p : opinionToUpdate.getChildren()) {
             Opinion o = (Opinion) p;
@@ -224,8 +212,7 @@
         opinionToUpdate.setTimeLastEdited(LocalDateTime.now());
         opinionRepository.save(opinionToUpdate);
-        return null;
-    }
-
-    public String update_Thread(String newTitle, String newContent, Long newTargetSubjectId, Long newParentThreadId, Long postId) {
+    }
+
+    public void update_Thread(String newTitle, String newContent, Long newTargetSubjectId, Long newParentThreadId, Long postId) {
         _Thread _threadToUpdate = _threadRepository.findByPostId(postId);
 
@@ -235,19 +222,19 @@
         _threadToUpdate.setTargetSubject(newTargetSubject);
 
-        _Thread newParentThread = null;
-        if(newParentThreadId != -1) {
-            newParentThread = _threadRepository.findByPostId(newParentThreadId);
-            if (!newParentThread.getTargetSubject().equals(newTargetSubject))
-                throw new IncompatiblePostId("Мислењето не припаѓа во специфицираната секција за дискусија.");
-            if (_threadToUpdate.getChildren().contains(newParentThread))
-                throw new DisallowedOperationException("Мислењето не може да се постави како дете на негово дете (бесконечна рекурзија)");
-        }
-        _threadToUpdate.setParent(newParentThread);
+        if(newParentThreadId != null) { //samo ako e specificirano
+            _Thread newParentThread = _threadRepository.findByPostId(newParentThreadId);
+
+            if (_threadToUpdate.getParent() == null || _threadToUpdate.getParent().getPostId().equals(postId)) {
+                _threadToUpdate.setParent(newParentThread);
+            }//samo ako e naslovniot post ili directChild
+            } else if(_threadToUpdate.getParent() != null) {
+            _threadToUpdate.setParent(null);
+            }
 
             if(_threadToUpdate.getParent() == null) {
              _threadToUpdate.setTitle(newTitle);
             } else {
-                _threadToUpdate.setTitle(null);
-            }
+             _threadToUpdate.setTitle(null);
+             }
 
          for(Post p : _threadToUpdate.getChildren()) {
@@ -257,5 +244,4 @@
          _threadToUpdate.setTimeLastEdited(LocalDateTime.now());
           _threadRepository.save(_threadToUpdate);
-          return null;
     }
 
@@ -294,5 +280,4 @@
         if (action.equals("resolve")) report.setResolved(true);
         else if (action.equals("open")) report.setResolved(false);
-        postReportRepository.save(report);
      }
 
Index: springapp/src/main/java/mk/profesori/springapp/Service/RegistrationService.java
===================================================================
--- springapp/src/main/java/mk/profesori/springapp/Service/RegistrationService.java	(revision 4abf55a556ca76069528c751a92cddaa146d108d)
+++ springapp/src/main/java/mk/profesori/springapp/Service/RegistrationService.java	(revision e49d1b6f77f15934314680ef2f5f20fec4987e7b)
@@ -45,5 +45,5 @@
                 String tokenToResend = customUserDetailsService
                         .createToken(userRepository.findByEmail(request.getEmail()).get());
-                String link = "http://192.168.0.29:8080/registration/confirm?token=" + tokenToResend;
+                String link = "http://192.168.0.19:8080/registration/confirm?token=" + tokenToResend;
                 emailSender.send(request.getEmail(), emailSender.buildEmail(request.getUsername(), link));
                 return tokenToResend;
@@ -66,5 +66,5 @@
                         UserRole.REGULAR));
 
-        String link = "http://192.168.0.29:8080/registration/confirm?token=" + token;
+        String link = "http://192.168.0.19:8080/registration/confirm?token=" + token;
 
         emailSender.send(request.getEmail(), emailSender.buildEmail(request.getUsername(), link));
